/* **********************************************************************************
 * Das Modul stellt Funktionen, Eventhandler und Variablen und einen Background 
 * Worker fr die automatische	Berechnung zur Verfgung.
 ********************************************************************************** */

var VELOSITY = 0;					// Geschwindigkeit mit der der nchste Wert berechnet wird.
var TIMELAPS = 0;					// Wartezeit fr die Iterationen in der Berechnung der Werte.
var timelapsHour = 0;				// Die Stunden der Wartezeit.
var timelapsMinute = 0;			// Die Minuten der Wartezeit.
var timelapsSecond = 0;			// Die Sekunden der Wartezeit.
var timelapsMillisecond = 0;		// Die Millisekunden der Wartezeit.
var da = "";								// Variable fr das aktuelle Datum der automatischen Berechnungen.
var wAutomaticTime;				// Background Worker Variable
var channel = null;					// Variable des Bradcast Channel zum Worker und back.
var checkboxIsClicked = 0;		// "Bis zu Datum" ist markiert oder demarkiert
var workerActualEndless;			// Zeigt an das der Worker "Mit aktuellem Datum" aktiv ist
var DELAY = 0;						// Variable fr die zustzliche Wartezeit bei den Berechnungen (Hier Ausgabe)
var popup = null;						// Daten Ausgabefenster

// Einen neuen Broadcast Channel erstellen.
//
channel = new BroadcastChannel ("com");
channelExtern = new BroadcastChannel ("comExtern");

				// ffnet ein neues Fenster
				//
				var browserX;
				var browserY = (screen.height / 2) - 130;			
				var popup_window;
				function openNew(url, windowName, width, height){
					browserX = (screen.width / 2) - (width / 2);
					browserY = (screen.height / 2) - (height / 2);
					popup_window = false;

					if ( (popup_window == false) || (popup_window.closed == true) ){
						popup_window = window.open(url ,windowName, "screenx=" + browserX + ", screeny=" + browserY + ", toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width=" + width + ", height=" + height + "" );
						if (popup_window == null)
							alert("Pop-up Blocker ist eingeschaltet! \n Bitte fge diese Seite zur Erlaubtliste des Browsers hinzu!");
						else
							popup_window.document.title = windowName;
					}
						popup_window.focus();
					return popup_window;
				}

// Objekt automatische Berechnung "Mit aktuellem Datum" Overlay.	
//
var objCalcActualDate = document.getElementById("calcActualDateAutomatic");	
var objCalcActualDateAutomatic = document.getElementById("dateAutomatic");
var objCalcActualTimeAutomatic = document.getElementById("timeAutomatic");
var objCalcActualSecondAutomatic = document.getElementById("secondAutomatic");
var objCalcActualMSecondAutomatic = document.getElementById("msecondAutomatic");


// Objekt automatische Berechnung "Ab gewhltem Datum" Overlay.	
//
var objCalcChoiceDate = document.getElementById("calcChoiceDateAutomatic");
var objCalcChoiceDateAutomatic = document.getElementById("choiceDateAutomatic");
var objCalcChoiceTimeAutomatic = document.getElementById("choiceTimeAutomatic");
var objCalcChoiceSecondAutomatic = document.getElementById("choiceSecondAutomatic");
var objCalcChoiceMSecondAutomatic = document.getElementById("choiceMsecondAutomatic");


// Objekt automatische Berechnung "Bis gewhltem Datum" Overlay.	
// 
var objCalcUntilDateAutomatic = document.getElementById("calcUntilDateAutomatic");
var objUntilDateAutomatic = document.getElementById("untilDateAutomatic");
var objCalcUntilTimeAutomatic = document.getElementById("untilTimeAutomatic");
var objCalcUntilSecondAutomatic = document.getElementById("untilSecondAutomatic");
var objCalcUntilMSecondAutomatic = document.getElementById("untilMsecondAutomatic");


// Objekt automatische Berechnung "Zeitsprung"
//	
var objCalcActualDateHour = document.getElementsByClassName("calcActualDateHour");
var objCalcActualDateMinute = document.getElementsByClassName("calcActualDateMinute");
var objCalcActualDateSecond = document.getElementsByClassName("calcActualDateSecond");
var objCalcActualDateMillisecond = document.getElementsByClassName("calcActualDateMillisecond");


// Objekt automatische Berechnung Geschwindigkeit der nchsten Berechnung.
//
var objVelosity = document.getElementsByClassName("velosity")[0];

 // Objekte der beiden Buttons "Abbrechen" und "Berechnen der automatischen Berchnung
 // bei Klick auf den Radio Button "Automatisch".
 //
var objAutoCancel = document.getElementById("autoCancel");	
var objAutoCalc = document.getElementById("autoCalc");



// Event Listener automatische Berechnung "Mit aktuellem Datum"
//
objCalcActualDate.addEventListener ("click", function () {
	
	// Die Geschwindigkeit auf Startwert setzen.
	objVelosity.value = 500;
	
	// Alle Eingabeboxen "Ab gewhltem Datum" zurcksetzen und unbedienbar machen
	//
	objCalcChoiceDate.checked = "";
	objCalcChoiceDateAutomatic.value = "";
	objCalcChoiceTimeAutomatic.value = "00:00";
	objCalcChoiceSecondAutomatic.value = "0";
	objCalcChoiceMSecondAutomatic.value = "0";

	objCalcChoiceDateAutomatic.disabled = true;
	objCalcChoiceTimeAutomatic.disabled = true;
	objCalcChoiceSecondAutomatic.disabled = true;
	objCalcChoiceMSecondAutomatic.disabled = true;
	
	// Den Worker fr Datum ab Aktuellem des Overlays starten
	startWorker();
});



// Event Listener automatische Berechnung "Ab Gewhltem Datum"
//

objCalcChoiceDate.addEventListener ("click", function () {

	// Radio Button "Ab aktuellem Datum" demarkieren
	objCalcActualDate.checked = "";

	// Alle Eingabeboxen bedienbar machen
	objCalcChoiceDateAutomatic.disabled = false;
	objCalcChoiceTimeAutomatic.disabled = false;
	objCalcChoiceSecondAutomatic.disabled = false;
	objCalcChoiceMSecondAutomatic.disabled = false;
	
	// Den Worker fr Datum ab Aktuellem des Overlays stoppen
	stopWorker();
	
});


// Event Listener automatische Berechnung "Bis Gewhltem Datum"
//
objCalcUntilDateAutomatic.addEventListener ("click", function () {

		if (checkboxIsClicked == 0){
			checkboxIsClicked++;
			// Alle Eingabeboxen "Bis gewhltem Datum" bedienbar machen und Lschen
			//
			objUntilDateAutomatic.disabled = false;
			objCalcUntilTimeAutomatic.disabled = false;
			objCalcUntilSecondAutomatic.disabled = false;
			objCalcUntilMSecondAutomatic.disabled = false;
		}else{
			checkboxIsClicked--;
			// Alle Eingabeboxen "Bis gewhltem Datum" unbedienbar machen und Lschen
			//
			objUntilDateAutomatic.disabled = true;
			objCalcUntilTimeAutomatic.disabled = true;
			objCalcUntilSecondAutomatic.disabled = true;
			objCalcUntilMSecondAutomatic.disabled = true;
			objUntilDateAutomatic.value = "";
			objCalcUntilTimeAutomatic.value = "00:00";
			objCalcUntilSecondAutomatic.value = "0";
			objCalcUntilMSecondAutomatic.value = "0";
		}

});


// Ebventhandler fr Klick auf "Abbrechen" im Overlay.
//
objAutoCancel.addEventListener("click", function () {
	// Wenn der Worker fr die Berchnung "Ab aktuellem Datum" endlos luft,
	// dann stoppe Ihn
	if (workerActualEndless) stopWorkerActualDateEndless();
	// Wert fr die Markierung der Checkbox auf 0 setzen.
	checkboxIsClicked = 0;
	// "Ab gewhltem Datum" alles Lschen
	//
	if (objCalcChoiceDate.checked)
		console.log("Radio Ab gewhltem Datum");
	// "Bis zum Datum" alles Lschen
	//	
	if (objCalcUntilDateAutomatic.checked){
		objCalcUntilDateAutomatic.value = "";
		objUntilDateAutomatic.disabled = true;
		objCalcUntilTimeAutomatic.disabled = true;
		objCalcUntilSecondAutomatic.disabled = true;
		objCalcUntilMSecondAutomatic.disabled = true;
		objCalcUntilDateAutomatic.checked = "";
		objUntilDateAutomatic.value = "";
		objCalcUntilTimeAutomatic.value = "00:00";
		objCalcUntilSecondAutomatic.value = "0";
		objCalcUntilMSecondAutomatic.value = "0";		
	}
	objCalcManual.checked = "checked";			// Radio Button Manuelle Berechnung aktivieren.
	objCalcAutomatic.checked = "";				// Radio Button Automstiach berechnung deaktivieren.
	divAutomatic.style.visibility = "hidden";	// Auswahl Div automatische Berechnung wegschalten.
	objCalc.disabled = false;					// Button Manuell "Berechnen" aktivieren.
	eraseOutputFields();						// Die Ausgabefelder lschen.
	enableDateTimePicker();						// Datums und Zeitpicker einschalten.
	setActualDateAndTime();						// Aktuelles Datum und Uhrzeit als Startdatum setzen.
	if (wAutomaticTime) stopWorker();			// Stopt den Worker fr das Datum Overlay.
});



// Ebventhandler fr Klick auf "Berechnen" im Overlay.
//
objAutoCalc.addEventListener("click", function () {

	eraseOutputFields();						// Alle Ausgabefelder Lschen.
	divAutomatic.style.visibility = "hidden";	// Auswahl Div automatische Berechnung wegschalten.
	setActualDateAndTime();						// Aktuelles Datum und Uhrzeit als Startdatum setzen.
	
	// Mit aktuellem PC Datum soll berechnet werden ...
	// ohne ein Enddatum endlos
	//
	if (objCalcActualDate.checked == true && (objCalcUntilDateAutomatic.checked == false) ){
	
		// dann die Delay Zeit in Millisekunden ermitteln.
		// Kleiner 24 Stunden
		if ( objCalcActualDateHour[0].value > 0 ) timelapsHour = objCalcActualDateHour[0].value;
		if ( objCalcActualDateMinute[0].value > 0 ) timelapsMinute = objCalcActualDateMinute[0].value;
		if ( objCalcActualDateSecond[0].value > 0 ) timelapsSecond = objCalcActualDateSecond[0].value;
		if ( objCalcActualDateMillisecond[0].value > 0 ) timelapsMillisecond = objCalcActualDateMillisecond[0].value;
		TIMELAPS = (3600000 * parseInt(timelapsHour)) + (60000 *  parseInt(timelapsMinute)) + ( 1000 * parseInt(timelapsSecond)) + parseInt(timelapsMillisecond);
		VELOSITY = objVelosity.value;
		document.getElementById("mstimelaps").value = "N/A";
		document.getElementById("msvelosity").value = VELOSITY;
		// Stoppt den Worker fr das Datum Overlay.
		//
		if (wAutomaticTime) stopWorker();
		//Popup Fenster fr Datenausgabe beim Laden des primren Fensters ffnen
		//
		popup = openNew("./outputData.html", "outputData", 970, 820);

		// Den Background Worker fr die Berechnung ber die aktuelle Uhrzeit erstellen und starten
		//
		startWorkerActualEndless(TIMELAPS, VELOSITY);
	// Mit aktuellem PC Datum soll berechnet werden ...
	// bis zu einem Enddatum
	//
	}else if( (objCalcActualDate.checked == true) && (objCalcUntilDateAutomatic.checked == true) ){
		alert("Noch nicht implementiert! Mit aktuellem Datum bis zu einem Enddatum: " + TIMELAPS + " - " + VELOSITY);
	// Ab gewhltem Datum soll endlos berechnet werden ...
	//
	}else if ( (objCalcChoiceDate.checked == true) && (objCalcActualDate.checked == false) && (objCalcUntilDateAutomatic.checked == false) ){
		alert("Noch nicht implementiert! Ab gewhltem Datum Endlos: " + TIMELAPS + " - " + VELOSITY);
	}else if ((objCalcChoiceDate.checked == true) && (objCalcUntilDateAutomatic.checked == true) && (objCalcActualDate.checked == false) ){
		alert("Noch nicht implementiert! Ab gewhltem Datum bis zu einem Enddatum: " + TIMELAPS + " - " + VELOSITY);
	}

});

// Hier wird der Worker fr die Berechnungen "Ab aktuellen Datum"
// erstellt.
//
async function startWorkerActualEndless(timelaps, velosity){
	var dat = null;
	var startProgressTime = 0;				// Startzeit fr die Verarbeitungsdauer Ausgabe
	var stopProgressTime = 0;				// Stopzeit fr die Verarbeitungsdauer Ausgabe
	var diffProgressTime = 0;				// Die Zeitdifferenz der Verarbeitung Ausgabe
	
	// Wenn der Browser Worker kennt.
	if(typeof(Worker) !== "undefined") {
						
		if(typeof(workerActualEndless)=="undefined") {
							
			// Neues WebWorker Objekt generiert aus der JavaScript Datei.
			// Achtung: Bei lokalen Dateien muss der Browser mit dem
			// Kommandline Parameter: "allow-file-access-from-files" gestartet
			// werden. Andernfalls unter einem Webserver starten.
			//
			workerActualEndless = new Worker("../../Bibliotheken/Sonne-Mond/worker-automatic-actualdate-endless.js" );			
		}
		if (workerActualEndless){
			// Lasse dem Worker 100 ms zeit um an den Start zu gehen
			await Sleep(100);
			workerActualEndless.postMessage("timelaps=" + timelaps);
			workerActualEndless.postMessage("delay=" + velosity);
			// Kontrolldatum ist nicht vorhanden.
			output.value = "N/A";
			// Event Que ber die alle Daten vom WebWorker eintreffen.
			//
			workerActualEndless.onmessage = function (event) {
				// Der zu sendende String mit den Daten
				//sendString = "";
				// Ermittelt die Anfangszeit der Verarbeitung in Millisekunden fr das Julianische Datum
				startProgressTime = new Date();

				// Im Array splitData findet man zwei Werte als Key=Value.
				// Sie sind durch "=" getrennt.
				splitData = event.data.split("=");
				// Hier, nach dem Key, die einzelnen Ergebnisse den Ausgabebereichen
				// zuweisen.
				// Das aktuelle Datum und die Uhrzeit
				if (splitData[0] == "DateAndTime"){
					dat = new Date(splitData[1]);

					// Das Datum im Kalender Picker ausgeben
					document.getElementById("date").valueAsDate = dat;
					// Die Uhrzeit im Time Picker ausgeben
					document.getElementById("time").value = LPad(dat.getHours(), 2, "0") + ":" + LPad(dat.getMinutes(), 2, "0");
					// Die Sekunden im Number Picker
					document.getElementById("second").value = LPad(dat.getSeconds(), 2, "0");
					dat = null;
				}
				// Die Milli Sekunden im Number Picker
				if (splitData[0] == "DateAndTimeMilliseconds"){
					document.getElementById("msecond").value = splitData[1];
				}
				// Die normale Uhrzeit ausgeben
				if (splitData[0] == "UTC"){
					document.getElementById("LT").value = splitData[1];
				}
				// Universal Time = UT ausgeben
				if (splitData[0] == "UT"){
					document.getElementById("UT").value = splitData[1];
					//sendString += "UT = " + splitData[1] + '\t';
				}
				// Das Julianischhe Datum ausgeben
				if (splitData[0] == "JD"){
					document.getElementById("JD1").value = splitData[1];
					//sendString += "JD = " + splitData[1] + '\t';
				}
				// Datum und Uhrzeit berechnet aus dem Julianischen Datum ausgeben
				if (splitData[0] == "JDDate"){
					document.getElementById("DateJD1").value = splitData[1];
				}
				// Das modifizierte Julianische Datum ausgeben
				if (splitData[0] == "MJD"){
					document.getElementById("MJD").value = splitData[1];
				}
				// Die Rckrechnung von Datum und Uhrzeit aus dem MJD
				if (splitData[0] == "MJDDate"){
					document.getElementById("DateMJD").value = splitData[1];
				}
				// Die Verarbeitungsgeschwindigkeit der Berechnung der Werte
				if (splitData[0] == "Progress"){
					document.getElementById("msprogresstime").value = (parseInt(splitData[1]) + diffProgressTime);
				}
				// Die Verarbeitungsgeschwindigkeit der Berechnung der Werte
				
				// Die vom Backround Worker berechneten Daten, die in einem Textfeld ausgegeben werden sollen
				// an outputData.html senden
				if (splitData[0] == "sendedWholeDataAsString"){
					channelExtern.postMessage("dataOutput=" +  splitData[1] );
				}
				
				// Ermittelt die Endzeit der Verarbeitung in Millisekunden fr das Julianische Datum
				stopProgressTime = Date.now();
				// Wenn die neue Verarbeitungszeit grer ist als die letzte ... 
				if ( parseInt(stopProgressTime - startProgressTime) > diffProgressTime){
					// dann speichere die neue Verarbeitungszeit als die Hhere ...
					diffProgressTime = parseInt(stopProgressTime - startProgressTime);
					// und ist die neue Verarbeitungszeit grer als die Wartezeit ...
					if ( diffProgressTime > DELAY)
						// dann passe die Wartezeit an plus eine kleine Sicherheit
						DELAY = diffProgressTime + 10;
				}

			};
		
		}
		
	// Der Browser kennt den WebWorker nicht und gibt eine Fehlermeldung aus.
	} else {
		alert("Sorry, your browser does not support Web Workers...");
	}
	
}


// Setzt die aktuelle Uhrzeit im Overlay fr die autom. Berechnungen.
//
function setActualDateAndTimeAutomatic(){
	var h = "";
	var m = "";
	var s = "";
	var ms = "";
	
	// Datumspicker mit aktuellem Datum versehen.
	da = new Date();								// Aktuelles Datum holen
	objCalcActualDateAutomatic.valueAsDate = da;	// und dem Datumspicker zuweisen
	// Stunde und Minute mit "0" auffllen und Time Picker
	// damit initialisieren.
	if ((h = da.getHours()) < 10)
		h = LPad(h, 2, "0");
	if ((m = da.getMinutes()) < 10)
		m = LPad(m, 2, "0");
	objCalcActualTimeAutomatic.value = h + ":" + m;
	// Sekunden mit "0" auffllen und Sekunden Picker
	// damit initialisieren.
	s = da.getSeconds();
	objCalcActualSecondAutomatic.value = s;
	// Millisekunden und Millisekunden Picker
	// damit initialisieren.
	ms = da.getMilliseconds();
	objCalcActualMSecondAutomatic.value = ms;
	// Startet den Backgroundworker fr das Datum des Overlays....
	if (!wAutomaticTime) startWorker();

}



// Eventhandler des Input Elements fr die Geschwindigkeit = Delay der Berechnungen.
// Wird ausgelst bei nderung des Wertes im Eingabefeld.
//
document.getElementsByClassName("velosity")[0].addEventListener ("change",  function () {
	// Der Wert der Geschwindigkeit wird dann im Broadcast Kanal gesendet.
	// Im Worker wird der Wert dann empfangen und die Rechengeschwindigkeit
	// neu eingestellt.
	//
	channel.postMessage(document.getElementsByClassName("velosity")[0].value);
});



// Erstellt den neuen Worker fr das Overlay und startet die Threads.
//
function startWorker()
{					
	// Worker erstellen, wenn er nicht vorhanden ist.
	//
	if(typeof(Worker)!=="undefined") {
										
		if(typeof(wAutomaticTime)=="undefined") {
								
			// Neues WebWorker Objekt generiert aus der JavaScript Datei.
			// Achtung: Bei lokalen Dateien muss der Browser mit dem
			// Kommandline Parameter: "allow-file-access-from-files" gestartet
			// werden. Andernfalls unter einem Webserver starten.
			//
			wAutomaticTime = new Worker("../../Bibliotheken/Sonne-Mond/worker-automatictime.js" );					
		}
		// Event Que ber die alle Daten vom WebWorker eintreffen.
		//
		wAutomaticTime.onmessage = function (event) {
			// Im Array splitData findet man zwei Werte als Key=Value.
			// Sie sind durch "=" getrennt.
			splitData = event.data.split("=");
			// Hier, nach dem Key, die einzelnen Ergebnisse den Ausgabebereichen
			// zuweisen.
			if (splitData[0] == "Date")
				document.getElementById("dateAutomatic").valueAsDate=splitData[1];
			if (splitData[0] == "StundeMinute")
				document.getElementById("timeAutomatic").value=splitData[1];
			if (splitData[0] == "Second")
				document.getElementById("secondAutomatic").value=splitData[1];
			if (splitData[0] == "MSecond")
				document.getElementById("msecondAutomatic").value=splitData[1];
		};
	// Der Browser kennt den WebWorker nicht und gibt eine Fehlermeldung aus.
	} else {
			document.getElementById("resultError").innerHTML="Sorry, your browser does not support Web Workers...";
	}
}


// Der Eventhandler empfngt die Messages vom Worker oder
// einem anderen Teil der Wbpage, wie Tab's oder Popups.
// Man kann von allem Empfangen die denselben Kanal benutzen.
//
channel.onmessage = function (e){
	// Die vom Worker gemeldete aktuelle Delay im Overlay eintragen.
	document.getElementsByClassName("returnedvelosity")[0].value = e.data;
}


channelExtern.onmessage = function (e){
		// Im Array splitData findet man zwei Werte als Key=Value.
		// Sie sind durch "=" getrennt.
		splitData = e.data.split("=");

		// Das Ausgabefenster soll geschlossen werden
		if (e.data == "Cancel"){
				popup.close();
		}
}


// Beendet den Worker fr die Berechnungen vom "Aktuellen Datum" endlos und die Threads.
//
function stopWorkerActualDateEndless()
{
	// Worker beenden.
	if (workerActualEndless){
		workerActualEndless.terminate();
		workerActualEndless = undefined;
	}

}


// Beendet den Worker fr das Automatische Overlay und die Threads.
//
function stopWorker()
{
	// Worker beenden.
	if (wAutomaticTime){
		wAutomaticTime.terminate();
		wAutomaticTime = undefined;
	}

}
