					/* ***************** Variablen Deklarationen - Variable declarations ************************ */

					var ISDST;									// Zeigt an, ob Daylight Saving Time
																			// Indicates whether Daylight Saving Time
					var TZ = 0;									// Nimmt die Zeitzone auf
																			// Accepts the time zone
					var saveMoonRiseSetDay = 0;	// Speichert den berechneten Tag mit Berechnung des Moonrise/set
																			// Saves the calculated day with calculation of the moonrise/set
					var saveMoonRiseSetMonth = 0;// Speichert den berechneten Monat mit Berechnung des Moonrise/set
																			// Saves the calculated month with calculation of the moonrise/set
					var saveMoonRiseSetYear = 0;	// Speichert den berechnete Jahr mit Berechnung des Moonrise/set
																			// Saves the calculated year with calculation of the moonrise/set
					var saveMoonRiseSetDST = 0;	// Speichert Sommer/Winterzeit mit Berechnung des Moonrise/set
																			// Saves the summer/winter time with calculation of the moonrise/set
					var saveMoonRiseSetTZ  = 0; 	// Speichert die Zeitzone für Berechnung des Moonrise/set
																			// Saves the time zone for calculation of the moonrise/set
					var saveMoonRiseSetLong  = 0; // Speichert den Längengrad für die Berechnung des Moonrise/set
																			// Saves the longitude for calculation of the moonrise/set
					var saveMoonRiseSetLat  = 0; 	// Speichert den Breitengrad für die Berechnung des Moonrise/set
																			// Saves the latitude for calculation of the moonrise/set
					var LCT = new Array();			// Ergebnisarray für den Mondaufgang
																			// Result array for moon rise
					var LCTS = new Array();		// Ergebnisarray für den Monduntergang
																			// Result array for moon set
					/* ***************** Verwendete Objekte - Used objects ************************ */
					
					// Objekt des Berechnen Buttons
					// Object of the calculation button
					var objCalc = document.getElementById("calc");
					// Objekt der Eingabe des zu berechnenden Jahres
					// Object of entry of the year to be calculated
					var objYear = document.getElementById("year");
					// Objekt der Eingabe des zu berechnenden Monats
					// Object of the input of the month to be calculated
					var objMonth = document.getElementById("month");
					// Objekt der Eingabe des zu berechnenden Tages
					// Object of the input of the day to be calculated
					var objDay = document.getElementById("day");
					// Objekte der Ausgabefelder
					// Objects of the output fields
					//
					// Objekt der Ausgabe des Schaltjahres
					// Object of the output of the leap year
					var objLeapYear = document.getElementById("leapyear");
					// Objekt der Eingabe/Ausgabe der Daylight Saving Time und Timezone
					// DST = 1 = Sommerzeit
					//
					// Object of input/output of the Daylight Saving Time and Timezone
					// DST = 1 = summer time
					var objDST = document.getElementById("dst");
					var objTZ = document.getElementById("tz");
					// Objekt der Ausgabe des neuen Längengrads nach der Zeit
					// Object of the output of the new longitude according to time
					var objLongitude= document.getElementById("longitude");
					// Objekt der Eingabe des lokalen Breitengrades
					// Object of the input of the local longitude
					var objLatitude =  document.getElementById("latitude");
					// Die Ausgabe des Datums des Mondaufgangs
					// The output for date and time of moon rise
					var objTimeMoonRise= document.getElementById("timemoonrise");
					// Die Ausgabe des Status des Mondaufgangs
					// The output for the state of moon rise
					var objStateMoonRise= document.getElementById("statemoonrise");
					// Die Ausgabe des Datums des Monduntergangs
					// The output for date and time of moon set
					var objTimeMoonSet= document.getElementById("timemoonset");
					// Die Ausgabe des Status des Monduntergangs
					// The output for the state of moon set
					var objStateMoonSet= document.getElementById("statemoonset");
					// Die Ausgabe des Azimuths des Mondaufgangs
					// The output for the azimuth of moon rise
					var objMoonRiseAz= document.getElementById("moonriseaz");
					// Die Ausgabe des Azimuths des Monduntergangs
					// The output for the azimuth of moon set
					var objMoonSetAz= document.getElementById("moonsetaz");
					// Die Ausgabe der Höhe des Mondaufgangs
					// The output for the hight of moon rise
					var objMoonRiseH= document.getElementById("moonriseh");
					// Die Ausgabe der Höhe des Monduntergangs
					// The output for the hight of moonset
					var objMoonSetH= document.getElementById("moonseth");
					// Die Ausgabe des Azimuths bei Mondhöchststand
					// The output of the azimuth at lunar apogee
					var objMoonHighAz= document.getElementById("moonhighaz");
					// Die Ausgabe des Datums mit Zeit bei Mondhöchststand
					// The output of the ate and time at lunar apogee
					var objMoonHighDate= document.getElementById("moonhighdate");
					// Die Höhe des Mondes über dem Horizont
					// The height of the Moon above the horizon
					var objMoonHighDeg= document.getElementById("moonhighdeg");
					// Objekt für den Abstand des Mondes
					// Object for the distance of the moon
					var objMoonDistance = document.getElementById("moondistance");
					// Objekt für den Durchmesser des Mondes
					// Object for the angular diameter of the moon
					var objMoonDiameter = document.getElementById("moondiameter");
					var d = new Date();					// Für die aktuelle Uhrzeit  - For the current time
					// Objekt der HTML Seite body
					// Object for this HTML page and body
					var objB = document.getElementById("b");